/*
*	Copyright (c) 2004
*		System Technology Laboratory Inc. all right reserved
*
*	jgrep {grep	-- Version 1.0
*		Author: Mita.Morihiko
*		Date:	2004.Oct.07
*/

#include <stdio.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>
#include <ctype.h>		/* tolower defined */
#define OUT(s)	fprintf(stdout, s)

struct PAT {
	char *p;		/* p^[ݒʒu */
	char *pp;		/* memchrɓnʒu */
	short plen;		/* p^[ */
	short ordr;		/* T[` */
	short not;		/* OtO */
} *pattb;			/* p^[e[uҏWGA */
static int pno;
static char *patf;			/* p^[t@Cݒʒu */
static char *pat;			/* p^[f[^ݒʒu */
static int aflg, fflg, cflg, iflg, vflg, nflg, pflg;

static char line[BUFSIZ*2];	/* f[^Ǎobt@ */
static char buf[100];
static int co[256];
static int kj_cd;		/* R[h^Cv(1:SJISA2:EUC) */
static int pre_read;
static int lc, lcount;			/* sAvsJE^ */
static int outsw;			/* o͍ςݔ */
static int fp;				/* Ǎt@C|C^ */
static int ac;				/* argc */
static char *av;			/* argv(t@C) */
static struct stat fsts;

extern char *memchr();

main(argc, argv)
int argc;
char *argv[];
{
	int j;
	void (*grep_func)(), mgrep(), xgrep(), lgrep(), hgrep();
	void agrep(), fmgrep(), fjgrep(), fegrep1(), fegrep2();
	while(*++argv && argv[0][0] == '-') {
		for(j=1;argv[0][j];j++) {
			if(argv[0][j] == 'f') {		/* p^[t@Cw */
				if(*(argv+1)) {
					patf = (char *)malloc(strlen(argv[1])+1);
					if(!patf) {
						fprintf(stderr, "jgrep: memory allocation error\n");
						exit(2);
					}
					strcpy(patf, argv[1]);	/* p^[t@C */
					fflg++;
					break;
				}
				else
					usage();
			}
			else if(argv[0][j] == 'a')	/* AND */
				aflg++;
			else if(argv[0][j] == 'c')	/* vŝݏo */
				cflg++;
			else if(argv[0][j] == 'i')	/* p召̋ʂȂ */
				iflg++;
			else if(argv[0][j] == 'n')	/* sԍo */
				nflg++;
			else if(argv[0][j] == 'v')	/* svso */
				vflg++;
			else if(argv[0][j] == 'V')	/* o[Wo */
				version();
			else if(argv[0][j] == '-' && argv[0][j+1] == 'h')
				help();			/* wvo */
			else
				pflg++;			/* p^[ƍl */
			/*	usage();		/* gpo */
		}
		if(strlen(argv[0]) == 1 || pflg)	/* "-*"̌ */
			break;
		argc--;
	}
	if(argc < 2)
		usage();
	ac = argc;
	if(fflg) {
		edit_pat(patf);
		if(aflg)
			grep_func = agrep;	/* ANDp^[ */
		else
			grep_func = fmgrep;	/* ORp^[ */
	}
	else if(aflg) {
		edit_and_pat(argv[0]);
		grep_func = agrep;		/* AND */
	}
	else {
		pat = (char *)malloc(strlen(argv[0])+1);
		if(!pat) {
			fprintf(stderr, "jgrep: memory allocation error\n");
			exit(2);
		}
		strcpy(pat, argv[0]);			/* wp^[ */
		if(iflg)
			edit_UL_pat();			/* Ȃiflg */
		if(iflg) {
			if((kj_cd = is_jtty()))
				grep_func = fjgrep;	/* pϊ */
			else {
				if(*pat >= 'a' && *pat <= 'z')
					grep_func = fegrep1;	/* p召1 */
				else
					grep_func = fegrep2;	/* p召2 */
			}
		}
		else if(vflg || nflg) {
			if(special_char(pat))		/* ӂꂽT */
				grep_func = lgrep;	/* p^[ϓsmT[` */
			else
				grep_func = hgrep;	/* p^[ŒsmT[` */
		}
		else if(special_char(pat))		/* ӂꂽT */
			grep_func = xgrep;	/* ӂꂽȊOŒT */
		else
			grep_func = mgrep;		/* OT */
	}
	fcntl(1, O_NDELAY);		/* stdout */
	if(ac == 2) {					/* stdin̓Ǎ */
		lcount = 0;
		fcntl(0, O_NDELAY);	/* stdin */
		(void )grep_func(ac, av, 0, pat);	/* p^[XLs */
		if(cflg)
			fprintf(stdout, "%d\n", lcount);	/* vs */
		exit(0);
	}
	while(*(++argv)) {
		lc = 0;
		lcount = 0;
		av = argv[0];
/*printf("av=%s pat=%s cflg=%d\n",av, pat, cflg);*/
		fp = open(av,0,0);			/* wt@CI[v */
		if(fp == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
			continue;
		}
		fcntl(fp, O_NDELAY);
		if(fstat(fp, &fsts) < 0) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
			continue;
		}
		if(fsts.st_size > BUFSIZ*5)
			pre_read++;
		(void )grep_func(ac, av, fp, pat);	/* p^[XLs */
		if(cflg) {
			if(ac > 3)			/* t@ĈƂ */
				fprintf(stdout, "%s:", av);	/* t@Co */
			fprintf(stdout, "%d\n", lcount);	/* vso */
		}
		close(fp);
	}
	if(outsw)		/* o͍ς */
		exit(0);	/* OK */
	else			/* o͂Ȃ */
		exit(1);	/* NO */
}

version()
{
	fprintf(stdout, "jgrep : version 1.0\n");
	exit(0);
}

/* gp\ */
usage()
{
	fprintf(stderr, "usage: jgrep [-Vacinv] pat|-f pat-file [file ...]\n");
	exit(1);
}

/* wvo */
help()
{
/*  if(LG && LG[0] == 'j' && LG[1] == 'a') {	*/
    if(is_jtty()) {
	OUT("\tjgrep̎g\n");
	OUT("\t\tjgrep [-Vacinv] pat|-f pat-file [file ...]\n");
	OUT("\twt@C܂͕W͂wp^[s𒊏o\n\n");
#ifdef NO_SJIS_PATCH
	OUT("\t-V o[W̕\\\n");
#else
	OUT("\t-V o[W̕\\n");
#endif
	OUT("\t-f pat-file: OR t@C̕p^[ŝꂩɈvs𒊏o\n");
	OUT("\t\tfgrep -f pat-fileɑ\n");
	OUT("\t-a: ANDi'PAT1 PAT2 ...'̂悤Ɏw肷B܂ -f pat-file Ŏw肷\n");
	OUT("\t\t擪'!'͂mnsƉ\n");
	OUT("\t\t'PAT1 !PAT2' grep PAT1 file | grep -v PAT2Ɠ\n");
	OUT("\t-c: YCJEg邾\n");
	OUT("\t-i: p啶ʂȂB(LANG)ł͊pʂȂ\n");
#ifdef NO_SJIS_PATCH
	OUT("\t-n: sԍ\\\n");
#else
	OUT("\t-n: sԍ\\n");
#endif
	OUT("\t-v: wp^[ɈvȂso͂\n");
#ifdef NO_SJIS_PATCH
	OUT("\tpat: p^[w肷BK\\͎gpoȂB\n");
#else
	OUT("\tpat: p^[w肷BK\͎gpoȂB\n");
#endif
	OUT("\tyӎz-f ORA1oCgłSJISQoCgHIT͏O\n");
	OUT("\t\tjgrep -av 'PAT1 PAT2'grep PAT1 | grep PAT2̌ʂ̕svs擾\n");
	OUT("\t\tgrep -v PAT1 | grep -v PAT2Ƃ͌ʂł͂Ȃ\n");
	OUT("\t\t̏ꍇ jgrep -a '!PAT1 !PAT2'gpꂽ\n\n");
    }
    else {
	OUT("\tusage: jgrep [-Vacinv] pat|-f pat-file [file ...]\n");
	OUT("\tselect match pattern lines from file or stdin\n\n");
	OUT("\t-V output version information\n");
	OUT("\t-f pat-file: OR search. obtain multi-pattern-lines from file\n");
	OUT("\t\tequivalent fgrep -f pat-file\n");
	OUT("\t-a: AND search (specify pat to 'PAT1 PAT2' or use -f pat-file)\n");
	OUT("\t\ttop of each PAT '!' is negative select.\n");
	OUT("\t\t'PAT1 !PAT2' is equivalent grep PAT1 file | grep -v PAT2.\n");
	OUT("\t-c: only count up\n");
	OUT("\t-i: ignore upper lower case letter\n");
	OUT("\t-n: print line no with output lines\n");
	OUT("\t-v: select non-matching lines\n");
	OUT("\tpat: search pattern with non regular expression.\n");
	OUT("\t[Warning] 1 byte select without -f OR search hit of SJIS/2 is excepted\n");
	OUT("\t\tresult of jgrep -av 'PAT1 PAT2' is unmatch line of grep PAT1 | grep PAT2\n");
	OUT("\t\tnot equivalent grep -v PAT1 | grep -v PAT2\n");
	OUT("\t\tin this case use jgrep -a '!PAT1 !PAT2'\n\n");
    }
	exit(0);
}

/* p^[̔zҏW */
edit_pat(file)
char *file;
{
	int no, l;
	char line[129], *lp;		/* 1p^[PQW܂ */
	FILE *fp, *fopen();
	int skey();
	fp = fopen(file, "r");
	if(fp == NULL) {
		fprintf(stderr, "jgrep: %s can't open pat file\n", file);
		exit(2);
	}
	no = 0;
	line[128] = '\0';
	while(fgets(line, 128, fp) != NULL) {
		l = strlen(line);
		if(l > 127) {
			fprintf(stderr, "jgrep: pattern strings too long\n");
			exit(2);
		}
		if(!(no%1000)) {		/* 1000PʂɃGAgmۂ */
			if(!no)
				pattb = (struct PAT *)malloc(sizeof(struct PAT)*1000);
			else
				pattb = (struct PAT *)realloc(pattb, sizeof(struct PAT)*(no+1000));
			if(!pattb) {
				fprintf(stderr, "jgrep: memory allocation error\n");
				exit(2);
			}
		}
		if(l) {
			line[l-1] = '\0';	/* '\n' CUT */
			if(aflg && line[0] == '!') {	/* negative PAT in and */
				if(l == 2) {
					fprintf(stderr, "jgrep: negative PAT is NULL\n");
					exit(2);
				}
				pattb[no].not++;
				strcpy(line, &line[1]);
				l--;
			}
		}
		pattb[no].p = (char *)malloc(l);
		if(!pattb[no].p) {
			fprintf(stderr, "jgrep: memory allocation error\n");
			exit(2);
		}
		strcpy(pattb[no].p, line);
		pattb[no].plen = --l;
		no++;
	}
	if(!no) {
		fprintf(stderr, "jgrep: %s pat file empty\n", file);
		exit(2);
	}
	qsort(pattb, no, sizeof(struct PAT), skey);
	pno = no;
	return;
}

/* AND ҏW */
edit_and_pat(av)
char *av;
{
	int l, ll;
	char *p;
	char *get_word();
	pattb = (struct PAT *)malloc(sizeof(struct PAT)*1000);
	p = av;
	while((p = get_word(p)) != NULL) {
		ll = 0;
		if(*p == '!') {
			if(strlen(p) == 1) {
				fprintf(stderr, "jgrep: negative PAT is NULL\n");
				exit(2);
			}
			strcpy(p, p+1);
			ll++;
			pattb[pno].not++;
		}
		l = strlen(p) + 1;
		pattb[pno].p = (char *)malloc(l);
		strcpy(pattb[pno].p, p);
		pattb[pno].plen = l - 1;
		if(pno < 1000)
			pno++;
		p += (l + ll);
	}
}

/* -iIvVp^[ҏW */
edit_UL_pat()
{
	register char *p;
	int n = 0;
	p = pat;
	while(*p) {
		if(*p & 0x80) {
			fprintf(stderr, "jgrep: -i option can specified only alpha-numeric PAT\n");
			exit(2);
		}
		if(*p >= 'A' && *p <= 'Z')
			*p += 0x20;
		else if(*p >= 'a' && *p <= 'z')
			;
		else
			n++;
		p++;
	}
	if(n == p - pat)	/* ʏ팟ł悢 */
		iflg = 0;
}

/* Xy[Xɋ؂ꂽPꒊo */
char *
get_word(avp)
char *avp;
{
	char *p;
	static short flg = 0;
	if(flg) {
		flg = 0;
		return(NULL);
	}
	while(*avp == ' ')
		avp++;
	p = avp;
	while(*p) {
		if(*p == ' ') {
			*p = '\0';
			return(avp);
		}
		p++;
	}
	flg++;
	return(avp);
}

/* qsortďo֐ */
skey(a, b)
struct PAT *a, *b;
{
	return(strcmp(a->p, b->p));
}

/* qsortďo֐ for -a */
okey(a, b)
struct PAT *a, *b;
{
	if(a->not - b->not)
		return(a->not - b->not);
	return(a->ordr - b->ordr);
}

/*
*	s̔F̕Kv̖p^[XL-1
*	擪T
*	p^[vAvsҏW
*	memchr()̃Xs[hɈˑĂ
*/
void
mgrep(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	short j;
	register char *m, *lp, *ep, *xp;
	register char *pa, *pe;
	register char *bp=0;
	register short psiz;
	register short match_flg = 0;
	pa = pat;
	psiz = strlen(pat);
	pe = pat + psiz;
	psiz--;
	m = pa;
read1:	lp = line;			/* cs̕ҏW */
	if(bp > lp) {
		while(bp < ep)
			*lp++ = *bp++;
	}
  	if((j = read(fp,lp,BUFSIZ)) <= 0) {	/* Ǎ */
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	bp = line;
	ep = lp + j;
	if(match_flg) {			/* vmFs̎cƕҏW */
		lp = memchr(lp , '\n', ep-lp);	/* Ǎ̏I[ */
#ifdef LONG_LINE
		if(!lp) {
			fprintf(stderr, "jgrep: %s line is too long\n", av);
			exit(2);
		}
#endif
		match_flg = 0;
		goto edit;
	}
	if(m != pa) {
		xp = lp;
		goto rem_chk;
	}
search:	if(!(lp = memchr(lp, *m, ep-lp))) {	/* 擪̌ */
		xp = ep;
		do {			/* ŏIs擪T */
			if(xp[-1] == '\n') {
				bp = xp;
				break;
			}
			xp--;
		} while(xp > bp);
		goto read1;
	}
	if(!psiz) {				/* PoCg */
		if(lp > bp && lp[-1] & 0x80 && chk_sjis(lp, bp)) {
			lp++;
			goto search;
		}
		xp = lp;
		goto match;
	}
	xp = lp;
ploop:	m++;				/* v񂩒ׂ */
	if(m == pe)			/* v */
		goto matcha;
	xp++;
	if(xp == ep) {
		do {		/* ŏIs擪T */
			if(lp[-1] == '\n') {
				bp = lp;
				break;
			}
			lp--;
		} while(lp > bp);
		goto read1;
	}
rem_chk:if(*xp == *m)
		goto ploop;
	m = pa;
	lp++;
	goto search;			/* svȂ̂Ŏ̂T */
matcha:	m = pa;
match:	do {		/* vs擪T */
		if(lp[-1] == '\n') {
			bp = lp;
			break;
		}
		lp--;
	} while(lp > bp);
	lp = memchr(xp, '\n', ep-xp);	/* vsI[T */
	if(!lp)	{			/* ̂œǂݍ */
		match_flg++;
		goto read1;
	}
edit:	write_one_line(bp, lp-bp);
	lp++;
	bp = lp;			/* ̐擪s */
	goto search;
}

/*
*	s̔F̕Kv̖p^[XL-2
*	p^[擪I['0'܂'1',' 'Ȃǂӂꂽp^[
*	Aɗ͏ȂTāAmemchr()ɓň֐
*/
void
xgrep(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	int j, psiz;
	register char *m, *lp, *ep, *xp;
	register char *pa, *pe, *pp;
	register char *bp=0;
	register short match_flg = 0;
	char *get_fewch(), *select_pp();
	pa = pat;
	psiz = strlen(pat);
	pe = pat + psiz;
	if(!pre_read) {
		pp = get_fewch(pa, pe);		/* D挟̌ */
		m = pp;
		psiz = pe - pp;
		psiz--;
	}
read1:	lp = line;			/* cs̕ҏW */
	if(bp > lp) {
		while(bp < ep)
			*lp++ = *bp++;
	}
  	j = read(fp,lp,BUFSIZ);		/* Ǎ */
	if(j <= 0) {
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	if(!bp && pre_read) {
		count_str(lp, j);
		pp = select_pp(pa);
/*printf("pp=%c\n",*pp);*/
		psiz = pe - pp;
		psiz--;
		m = pp;
	}
	bp = line;
	ep = lp + j;
	if(match_flg) {			/* vmFs̎cƕҏW */
		lp = memchr(lp , '\n', ep-lp);	/* Ǎ̏I[ */
		match_flg = 0;
		goto edit;
	}
	if(m != pp) {
		xp = lp;
		lp -= psiz;	/* sv̎̃XLJnʒu */
		goto rem_chk;
	}
search:	m = pp;
	lp = memchr(lp, *m, ep-lp);	/* ř */
	if(!lp) {				/*  */
		xp = ep;
		do {			/* ŏIs擪T */
			xp--;
			if(*xp == '\n') {
				bp = ++xp;
				break;
			}
		} while(xp > bp);
		goto read1;			/* Ǎ */
	}
	if(m - pa > lp - bp) {
		lp++;
		goto search;
	}
	if(m > pa) {
		xp = lp;
bloop:		m--;
		xp--;
		if(*m != *xp) {
			lp++;
			goto search;
		}
		if(m == pa)
			goto ploop1;
		goto bloop;
ploop1:		m = pp;
	}
	xp = lp;
ploop:	m++;				/* v񂩒ׂ */
	if(m == pe)			/* v */
		goto match;
	xp++;
	if(xp == ep) {
		for(xp--;xp > bp;xp--)	/* ŏIs擪T */
			if(*xp == '\n') {
				bp = ++xp;
				break;
			}
		goto read1;
	}
rem_chk:if(*xp == *m)
		goto ploop;
	lp++;
	goto search;			/* svȂ̂Ŏ̂T */
match:	do {		/* vs擪T */
		if(lp[-1] == '\n') {
			bp = lp;
			break;
		}
		lp--;
	} while(lp > bp);
	lp = memchr(xp, '\n', ep-xp);	/* vsI[T */
	if(!lp)	{			/* ̂œǂݍ */
		match_flg++;
		goto read1;
	}
edit:	write_one_line(bp, lp-bp);
	lp++;
	bp = lp;				/* ̐擪s */
	m = pp;
	goto search;			/* ̈v񌟍 */
}

/*
*	smAp^[T[`BXs[h͒x
*	(p^[ʒuŒ)
*/
void
hgrep(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	int j;
	register char *lp, *xp, *qp, *ep;
	register char *m, *pa, *pe;
	register char *bp=0;
	register int psiz;
	pa = pat;
	m = pa;
	psiz = strlen(pat);
	pe = pat + psiz;
	psiz--;
read1:	lp = line;
	if(bp > lp) {			/* csҏW */
		while(bp < ep)
			*lp++ = *bp++;
	}
  	j = read(fp,lp,BUFSIZ);		/* Ǎ */
	if(j <= 0) {
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	bp = line;
	ep = lp + j;
newline:qp = memchr(bp, '\n', ep-bp);	/* 1sҏW */
	if(!qp)
		goto read1;
	lc++;
	if(qp - bp <= psiz) {		/* p^[sZ */
		if(vflg)
			write_one_line(bp, qp-bp);
		qp++;
		bp = qp;
		goto newline;
	}
	lp = bp;
search:	lp = memchr(lp, *m, qp-lp-psiz);	/* 擪̌ */
	if(!lp) {					/*  */
		if(vflg)
			write_one_line(bp, qp-bp);	/* svso */
		qp++;
		bp = qp;
		goto newline;			/* ̍s */
	}
	/* SJISQoCg̈v}~ */
	if(!psiz) {
		if(xp > bp && xp[-1] & 0x80 && chk_sjis(xp, bp)) {
			lp++;
			goto search;
		}
		goto match;
	}
	xp = lp;
ploop:	m++;				/* v񂩒ׂ */
	if(m == pe)			/* v */
		goto matcha;
	xp++;
	if(*xp == *m)			/* v */
		goto ploop;
	lp++;
	m = pa;
	goto search;
matcha:	m = pa;
match:	if(!vflg)
		write_one_line(bp, qp-bp);	/* vso */
	qp++;
	bp = qp;			/* ̐擪s */
	goto newline;			/* ̍s */
}

/*
*	smAp^[T[`BXs[h͒x
*	(p^[ʒuϓ)
*/
void
lgrep(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	int j, psiz;
	register char *lp, *xp, *qp, *ep;
	register char *m, *pa, *pe, *pp;
	register char *bp=0;
	char *get_fewch(), *select_pp();
	pa = pat;
	psiz = strlen(pat);
	pe = pat + psiz;
	if(!pre_read) {
		pp = get_fewch(pa, pe);		/* D挟̌ */
		psiz = pe - pp;
		psiz--;
	}
read1:	lp = line;
	if(bp > lp) {			/* csҏW */
		while(bp < ep)
			*lp++ = *bp++;
	}
  	j = read(fp,lp,BUFSIZ);		/* Ǎ */
	if(j <= 0) {
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	if(!bp && pre_read) {
		count_str(lp, j);
		pp = select_pp(pa);
/*printf("pp=%x\n",*pp);*/
		psiz = pe - pp;
		psiz--;
	}
	bp = line;
	ep = lp + j;
newline:qp = memchr(bp, '\n', ep-bp);	/* 1sҏW */
	if(!qp)
		goto read1;
	lc++;
	if(qp-bp < pe-pa) {			/* p^[sZ */
		if(vflg)
			write_one_line(bp, qp-bp);
		qp++;
		bp = qp;
		goto newline;
	}
	lp = bp;
search:	m = pp;
	lp = memchr(lp, *m, qp-lp-psiz);	/* 擪̌ */
	if(!lp) {					/*  */
		if(vflg)
			write_one_line(bp, qp-bp);	/* svso */
		qp++;
		bp = qp;
		goto newline;			/* ̍s */
	}
	if(m > pa) {
		xp = lp;
bloop:		m--;
		xp--;
		if(*m != *xp) {
			lp++;
			goto search;
		}
		if(m == pa)
			goto ploop1;
		goto bloop;
ploop1:		m = pp;
	}
	xp = lp;
ploop:	m++;				/* v񂩒ׂ */
	if(m == pe)			/* v */
		goto match;
	xp++;
	if(*xp == *m)			/* v */
		goto ploop;
	lp++;
	goto search;
match:	if(!vflg)
		write_one_line(bp, qp-bp);	/* vso */
	qp++;
	bp = qp;	/* ̐擪s */
	goto newline;			/* ̍s */
}

/* 񒆂̕JEg */
count_str(lp, j)
register char *lp;
register int j;
{
	register char *ep;
	register int c;
	ep = lp + j;
	while(lp < ep) {
		c = *lp & 0xff;
		co[c]++;
		lp++;
	}
}

/* JEgŏ̕I */
char *
select_pp(pa)
register char *pa;
{
	register int c, oco=BUFSIZ;
	register char *pp;
	pp = pa;
	while(*pa) {
		c = *pa & 0xff;
/*printf("co[%x]=%d oco=%d\n",c,co[c],oco);*/
		if(co[c] < oco) {
			pp = pa;
			oco = co[c];
		}
		pa++;
	}
	return(pp);
}

/*
*	wp^[ɗ͏ȂT
*/
char *
get_fewch(pa, pe)
register char *pa, *pe;
{
	register char *pp, *m, *n;
	m = pa;
	n = pa;
	if(pe-pa < 2)
		return(pa);
	for(pp=pa;pp < pe;pp++)
		if(*pp != '0' && *pp != '1' && *pp != ' ') {
			if(*pp <= '9')		/* ł͐l̂ݔ肷 */
				m = pp;
		}
	else if(*n < *pp)			/* ' ' < '0' < '1' */
		n = pp;
	if(pp == pe) {		/* lspace΂̎w */
		if(m > pa)
			pp = m;	/* l̏̕Ȃƍl */
		else if(n > pa)
			pp = n;	/* ' ','0','1'ȂʂD悷 */
		else
			pp = pa;/* R[h΂ */
	}
	return(pp);
}

/*
*	AND
*/
void
agrep(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	int j, psiz;
	register char *lp, *qp, *ep;
	register char *bp=0;
	psiz = get_patminsz();
	if(!pre_read)
		select_pat_odr(0);
/*pre_read=1;*/
read1:	lp = line;
	if(bp > lp) {			/* csҏW */
		while(bp < ep)
			*lp++ = *bp++;
	}
  	j = read(fp,lp,BUFSIZ);		/* Ǎ */
	if(j <= 0) {
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	if(!bp && pre_read) {
		count_str(lp, j);
		select_pat_odr(1);
	}
	bp = line;
	ep = lp + j;
newline:qp = memchr(bp, '\n', ep-bp);	/* sm */
	if(!qp)
		goto read1;
	lc++;
	if(and_match_pat(bp, qp))		/* vp^[ */
		goto match;
	if(vflg)
		write_one_line(bp, qp-bp);	/* svso */
	qp++;
	bp = qp;
	goto newline;				/* ̍s */
match:	if(!vflg)
		write_one_line(bp, qp-bp);	/* vso */
	qp++;
	bp = qp;				/* ̍s擪 */
	goto newline;
}

/*
*	-f w̃t@C̕p^[Ɉvso͂
*	p^[̓\[gAoCiT[`ňvp^[̗L𔻕
*	fgrep -f ̌ɑ΂đF͖
*		fgrep -f pat1 file: 18/100	pat1(644s)Afile(77400s)
*		jgrep -f pat1 file: 18/100
*/
void
fmgrep(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	int j, psiz;
	register char *lp, *qp, *ep;
	register char *bp=0;
	int (*gpat_func)(), match_pat();
	psiz = get_patminsz();
	gpat_func = match_pat;
read1:	lp = line;
	if(bp > lp) {			/* csҏW */
		while(bp < ep)
			*lp++ = *bp++;
	}
  	j = read(fp,lp,BUFSIZ);		/* Ǎ */
	if(j <= 0) {
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	bp = line;
	ep = lp + j;
newline:qp = memchr(bp, '\n', ep-bp);	/* sm */
	if(!qp)
		goto read1;
	lc++;
	for(lp = bp;lp+psiz < qp;lp++)		/* 񑀍 */
		if(gpat_func(lp))		/* vp^[ */
			goto match;
	if(vflg)
		write_one_line(bp, qp-bp);	/* svso */
	qp++;
	bp = qp;
	goto newline;				/* ̍s */
match:	if(!vflg)
		write_one_line(bp, qp-bp);	/* vso */
	qp++;
	bp = qp;				/* ̍s擪 */
	goto newline;
}

/*
*	-i p啶AʂȂ 1 
*		strpbrkT[`
*/
void
fegrep1(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	short j, psiz;
	register char *m, *lp, *ep, *xp;
	register char *pa, *pe;
	register char *bp=0;
	char m2[3];
	register short match_flg = 0;
	pa = pat;
	m2[0] = toupper(*pa);
	m2[1] = pa[0];
	m2[2] = '\0';
	psiz = strlen(pat);
	pe = pat + psiz;
	psiz--;
	m = pa;
read1:	lp = line;			/* cs̕ҏW */
	if(bp > lp) {
		while(bp < ep)
			*lp++ = *bp++;
	}
  	if((j = read(fp,lp,BUFSIZ)) <= 0) {	/* Ǎ */
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	bp = line;
	ep = lp + j;
	*ep = '\0';
	if(match_flg) {			/* vmFs̎cƕҏW */
		lp = memchr(lp , '\n', ep-lp);	/* Ǎ̏I[ */
		match_flg = 0;
		goto edit;
	}
	if(m != pa) {
		xp = lp;
		goto rem_chk;
	}
search:	if(!(lp = (char *)strpbrk(lp, m2))) {	/* 啶ŒT */
		xp = ep;			/*  */
		do {			/* ŏIs擪T */
			if(xp[-1] == '\n') {
				bp = xp;
				break;
			}
			xp--;
		} while(xp > bp);
		goto read1;			/* Ǎ */
	}
	if(!psiz) {
		if(xp > bp && xp[-1] & 0x80 && chk_sjis(xp, bp)) {
			lp++;
			goto search;
		}
		xp = lp;
		goto match;
	}
	xp = lp;
ploop:	m++;				/* v񂩒ׂ */
	if(m == pe)			/* v */
		goto matcha;
	xp++;
	if(xp == ep) {
		for(lp--;lp > bp;lp--)	/* ŏIs擪T */
			if(*lp == '\n') {
				bp = ++lp;
				break;
			}
		goto read1;
	}
rem_chk:if((isupper(*xp)?tolower(*xp):*xp)  == *m)	/* v */
		goto ploop;
	m = pa;
	lp++;
	goto search;			/* svȂ̂Ŏ̂T */
matcha:	m = pa;
match:	do {		/* vs擪T */
		if(lp[-1] == '\n') {
			bp = lp;
			break;
		}
		lp--;
	} while(lp > bp);
	if(!(lp = memchr(xp, '\n', ep-xp))) {	/* vsI[T */
		match_flg++;			/* ̂œǂݍ */
		goto read1;
	}
edit:	write_one_line(bp, lp-bp);
	lp++;
	bp = lp;				/* ̐擪s */
	goto search;				/* ̈v񌟍 */
}

/*
*	-i p啶AʂȂ 1 
*		memchrT[`
*/
void
fegrep2(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	short j, psiz;
	register char *m, *lp, *ep, *xp;
	register char *pa, *pe;
	register char *bp=0;
	register short match_flg = 0;
	pa = pat;
	psiz = strlen(pat);
	pe = pat + psiz;
	psiz--;
	m = pa;
read1:	lp = line;			/* cs̕ҏW */
	if(bp > lp) {
		while(bp < ep)
			*lp++ = *bp++;
	}
  	if((j = read(fp,lp,BUFSIZ)) <= 0) {		/* Ǎ */
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	bp = line;
	ep = lp + j;
	if(match_flg) {			/* vmFs̎cƕҏW */
		lp = memchr(lp , '\n', ep-lp);	/* Ǎ̏I[ */
		match_flg = 0;
		goto edit;
	}
	if(m != pa) {
		xp = lp;
		goto rem_chk;
	}
search:	if(!(lp = memchr(lp, *m, ep-lp))) {	/* 擪̌ */
		xp = ep;			/*  */
		do {			/* ŏIs擪T */
			if(xp[-1] == '\n') {
				bp = xp;
				break;
			}
			xp--;
		} while(xp > bp);
		goto read1;			/* Ǎ */
	}
	if(!psiz) {
		if(xp > bp && xp[-1] & 0x80 && chk_sjis(xp, bp)) {
			lp++;
			goto search;
		}
		xp = lp;
		goto match;
	}
	xp = lp;
ploop:	m++;				/* v񂩒ׂ */
	if(m == pe)			/* v */
		goto matcha;
	xp++;
	if(xp == ep) {
		for(lp--;lp > bp;lp--)	/* ŏIs擪T */
			if(*lp == '\n') {
				bp = ++lp;
				break;
			}
		goto read1;
	}
rem_chk:if((isupper(*xp)?tolower(*xp):*xp)  == *m)	/* v */
		goto ploop;
	m = pa;
	lp++;
	goto search;			/* svȂ̂Ŏ̂T */
matcha:	m = pa;
match:	do {		/* vs擪T */
		if(lp[-1] == '\n') {
			bp = lp;
			break;
		}
		lp--;
	} while(lp > bp);
	lp = memchr(xp, '\n', ep-xp);	/* vsI[T */
	if(!lp) {				/* ̂œǂݍ */
		match_flg++;
		goto read1;
	}
edit:	write_one_line(bp, lp-bp);
	lp++;
	bp = lp;				/* ̐擪s */
	goto search;				/* ̈v񌟍 */
}

/*
*	-i ppɕϊAvT
*/
void
fjgrep(ac, av, fp, pat)
char *av;
char *pat;
int ac, fp;
{
	int j, psiz;
	register char *lp, *qp, *ep;
	register char *bp=0;
	char *(*gpat_func)(), *get_ULpat_euc(), *get_ULpat_sj(), *get_ULpat_en();
	psiz = strlen(pat);
	if(kj_cd == 2)		/* dtb */
		gpat_func = get_ULpat_euc;
	else			/* rihr */
		gpat_func = get_ULpat_sj;
read1:	lp = line;
	if(bp > lp) {			/* csҏW */
		while(bp < ep)
			*lp++ = *bp++;
	}
  	j = read(fp,lp,BUFSIZ);		/* Ǎ */
	if(j <= 0) {
		if(j == -1) {
			sprintf(buf, "jgrep: %s", av);
			perror(buf);
		}
		return;
	}
	bp = line;
	ep = lp + j;
newline:qp = memchr(bp, '\n', ep-bp);	/* sm */
	if(!qp)
		goto read1;
	lc++;
	for(lp = bp;lp+psiz < qp;lp++)		/* 񑀍 */
		if(!(lp=gpat_func(lp, pat)))	/* vp^[ */
			goto match;
	if(vflg)
		write_one_line(bp, qp-bp);	/* svso */
	qp++;
	bp = qp;
	goto newline;				/* ̍s */
match:	if(!vflg)
		write_one_line(bp, qp-bp);	/* vso */
	qp++;
	bp = qp;				/* ̍s擪 */
	goto newline;
}

/* vs̏o */
write_one_line(bp, len)
register char *bp;
register int len;
{
	len++;			/* call+1 */
	if(cflg) {
		lcount++;
		return;
	}
	if(ac > 3)
		fprintf(stdout, "%s:", av);
	if(nflg)
		fprintf(stdout, "%d:", lc);
	fwrite(bp, 1, len, stdout);
	if(ferror(stdout))
		perror("jgrep: writing output");
	outsw++;
}

/* 񒆍ŒZTCYԂ */
get_patminsz()
{
	int i, len;
	len = 128;
	for(i=0;i<pno;i++)
		if(len > pattb[i].plen)
			len = pattb[i].plen;
	return(len);
}

/* ANDvmF */
and_match_pat(p, ep)
register char *p, *ep;
{
	int i;
	for(i=0;i<pno;i++) {
		if(pre_read) {
			if(!pattb[i].not) {
				if(!is_match_pp(p, ep, i))
					return(0);
			}
			else {
				if(is_match_pp(p, ep, i))
					return(0);
			}
		}
		else {
			if(!pattb[i].not) {
				if(!is_match_pat(p, ep, pattb[i].p))
					return(0);
			}
			else {
				if(is_match_pat(p, ep, pattb[i].p))
					return(0);
			}
		}
	}
	return(1);
}

/* \ς */
is_match_pp(lp, ep, i)
register char *lp, *ep;
register int i;
{
	register char *xp, *m, *pa, *pp, *pe;
	register int plen;
	register char *bp;
	pp = pattb[i].pp;
	plen = strlen(pp);
	pe = pp + plen;
	bp = lp;
search:	if(ep-lp < plen)		/* p^[sZ */
		return(0);
	m = pp;
	plen = strlen(pattb[i].p);	/* 2004.Dec.21 BUG */
	lp = memchr(lp, *m, ep-lp);
	if(!lp)
		return(0);
	pa = pattb[i].p;
/*printf("m=%d pa=%d\n",m,pa);*/
	if(m > pa) {
		xp = lp;
bloop:		m--;
		xp--;
		if(*m != *xp) {
			lp++;
			goto search;
		}
		if(m == pa)
			goto ploop1;
		goto bloop;
ploop1:		m = pp;
	}
	xp = lp;
/*printf("m=%d pe=%d plen=%d\n",m,pe,plen);*/
re_loop:m++;
	if(m == pe) {		/* p^[v */
/*printf("HIT pa=%s plen=%d\n",pa,plen);*/
		/* SJISQoCg̈v}~ */
		if(plen == 1 && xp > bp && xp[-1] & 0x80 && chk_sjis(xp, bp)) {
			lp++;
			goto search;
		}
		return(1);
	}
	xp++;
	if(*m == *xp)
		goto re_loop;
	lp++;
	goto search;
}

/* ȕֈvmF */
is_match_pat(p, ep, pat)
register char *p, *ep, *pat;
{
	register char *np;
	register int plen;
	np = p;
	plen = strlen(pat);
	do {
		np = memchr(np, *pat, ep-np);
		if(!np)
			return(0);
		if(!strncmp(np, pat, plen)
			/* SJISQoCg̈v}~ */
			&& !(plen == 1 && np > p && np[-1] & 0x80 && chk_sjis(np, p)))
				return(1);
		np++;
	} while(np+plen < ep);
	return(0);
}

/* -aIvV̌Ȃׂ̂ */
select_pat_odr(sw)
int sw;
{
	int i, j, k;
	int c, oco;
	char *pa, *pp;
	if(!sw)
		return(long_pat_order());
	for(i=0;i<pno;i++) {
		oco = BUFSIZ;
		pa = pattb[i].p;
		while(*pa) {
			c = *pa & 0xff;
			if(co[c] < oco) {
				pp = pa;
				oco = co[c];
			}
			pa++;
		}
		pattb[i].pp = pp;
		pattb[i].ordr = 0;
	}
	for(i=0;i<pno;i++) {
		oco = BUFSIZ;
		for(j=0;j<pno;j++) {
			if(pattb[j].ordr)
				continue;
			c = *pattb[j].pp & 0xff;
			 if(co[c] < oco) {
				k = j;
				oco = co[c];
			}
		}
		pattb[k].ordr = i + 1;
	}
/*for(i=0;i<pno;i++)
printf("1 order=%d pa=%s pp=%c not=%d\n",pattb[i].ordr,pattb[i].p,*(pattb[i].pp),pattb[i].not);*/
	qsort(pattb, pno, sizeof(struct PAT), okey);
/*for(i=0;i<pno;i++)
printf("2 order=%d pa=%s pp=%c\n",pattb[i].ordr,pattb[i].p, *(pattb[i].pp));*/
}

/* Ƃ肠̂璲ׂ */
long_pat_order()
{
	int i, j, k, len;
	int okey();
	for(i=0;i<pno;i++) {
		len = 0;
		for(j=0;j<pno;j++) {
			if(pattb[j].ordr)
				continue;
			if(pattb[j].plen > len) {
				k = j;
				len = pattb[j].plen;
			}
		}
		pattb[k].ordr = i + 1;
	}
	qsort(pattb, pno, sizeof(struct PAT), okey);
}

/*
*	-iIvVEUCppɕϊ
*/
char *
get_ULpat_euc(lp, pat)
register char *lp;
register char *pat;
{
	register int kanji = 0;
	register int c;
	register char *p;
	p = lp;
loop:	c = *p & 0xff;
	if(!kanji) {
		if(c == 0xa3) {			/* EUC1p */
			p++;
			kanji++;
			goto loop;
		}
	}
	else {
		if(c >= 0xb0 && c <= 0xfa)	/* EUC2 */
			c -= 0x80;
		kanji = 0;
	}
	if(c >= 'A' && c <= 'Z')	/* <= */
		c += 0x20;
	if((int )*pat != c) {
		if(*lp & 0x80 && *(lp + 1) & 0x80)
			lp++;
		return(lp);
	}
	pat++;
	if(!*pat)
		return(NULL);
	p++;
	goto loop;
}

/*
*	-iIvVSJISppɕϊ
*/
char *
get_ULpat_sj(lp, pat)
register char *lp;
register char *pat;
{
	register int kanji = 0;
	register int c, c2 = 0;
	register char *p;
	p = lp;
loop:	c = *p & 0xff;
	if(!kanji) {
		if(c & 0x80) {
			if(c == 0x82) {			/* SJ1p */
				kanji++;
				p++;
				c2 = c;
				goto loop;
			}
			if( c <= 0x9f || c >= 0xe0 )	/* sj1 */
				lp++;
			return(lp);			/* Ji */
		}
	}
	else {
		if(c >= 0x4f && c <= 0x9a) {		/* SJ2p */
			if(c >= 0x81)
				c--;
			c -= 0x1f;
		}
		kanji = 0;
	}
	if(c >= 'A' && c <= 'Z')	/* <= */
		c += 0x20;
	if((int )*pat != c) {
		if(c2 == 0x82)
			lp++;
		return(lp);
	}
	pat++;
	if(!*pat)
		return(NULL);
	p++;
	goto loop;
}

/* oCiT[` from language-C */
match_pat(p)
register char *p;
{
	register int high,low,gp;
	register int ns;
	static int __scomp();
	if(*p < *pattb[0].p)
		return(0);
	if(*p > *pattb[pno-1].p)
		return(0);
	high = pno-1;
	low = 0;
	while(low <= high) {
		gp = (high + low) / 2;
		if((ns=__scomp(pattb[gp].p,p)) < 0)
			high = gp - 1;
		else if(ns > 0)
			low = gp + 1;
		else
			return(1);
		}
	return(0);
}

static
__scomp(a,b)
register char *a,*b;
{
	for(;*a;) {
		if(*a > *b)
			return(-1);
		else if(*a < *b)
			return(1);
		a++;
		b++;
		}
	return(0);
}

/* 𒲂ׂ */
#define SJIS 0x01
#define EUC  0x02
is_jtty()
{
	char *LG, *getenv();
	LG = getenv("LANG");
	if(!LG)
		return(0);
	if(LG[0] == 'j' && LG[1] == 'a') {
		if(is_sjisenv(LG))
			return(SJIS);
		else
			return(EUC);
	}
	return(0);
}

/* SJIS`邩 */
is_sjisenv(LG)
char *LG;
{
	char *eLG;
	eLG = LG + strlen(LG) - 3;
	while(LG <= eLG) {
		if(!strncmp(LG, "sjis", 4) || !strncmp(LG, "SJIS", 4))
			return(1);
		LG++;
	}
	return(0);
}

/* SJISǂ[`FbNȂƂ킩Ȃ */
chk_sjis(xp, bp)
register unsigned char *xp, *bp;
{
	register unsigned char *sp;
	sp = xp;
	for(xp--;xp >= bp;xp--) {
		if(!(issjc1((int )*xp) || issjc2((int )*xp)))
			break;
	}
	for(xp++;xp < sp;xp++) {
		if(issjc1((int )*xp) && issjc2((int )*(xp+1)))
			xp++;
	}
	if(xp > sp)
		return(1);
	else
		return(0);
}

/* wp^[̕^Cv𔻕ʂ */
special_char(ch)
char *ch;
{
	int len;
	len = strlen(ch);
	if(len < 2)
		return(0);
	if(*ch == '0' || *ch == '1' || *ch == '2' || *ch == ' ')
		return(1);
	/* SJIS2Ɉȉ̃p^[ */
	if(*ch == 'N' || *ch == 'R' || *ch == 'V' || *ch == 'X'
		|| *ch == 'c' || *ch == 'e' || *ch == 's' || *ch == 't')
		return(1);
	if(kanji_pat_inc(ch, len))	/* ppwőȂ */
		return(1);
	return(0);
}

/* p^[܂܂邩 */
kanji_pat_inc(ch, len)
register char *ch;
int len;
{
	register char *ech;
	register int c;
	ech = ch + len;
	for(;ch < ech;ch++) {
		c = *ch & 0xff;
		if(c >= 0x80)
			return(1);
	}
	return(0);
}

/* SJIS1oCg */
issjc1(c)
register int	c;
{
	return ( (0x80 <= c && c <= 0x9f)
	      || (0xe0 <= c && c <= 0xfc) );
}

/* SJIS2oCg */
issjc2(c)
register int	c;
{
	return ( (0x40 <= c && c <= 0x7e)
	      || (0x80 <= c && c <= 0xfc) );
}
